import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData(){

        return hamletData;
    }

    public void changeFromHamletToLeon() {

        String patternString1 = ("HAMLET");


        System.out.println(Pattern.compile(patternString1,Pattern.
                CASE_INSENSITIVE).matcher(hamletData).replaceAll("LEON"));


    }
    public void changeFromHoratioToTariq(){

        String patternString2 = ("HORATIO");


        System.out.println(Pattern.compile(patternString2,Pattern.
                CASE_INSENSITIVE).matcher(hamletData).replaceAll("TARIQ"));


    }


    public int findHamlet(){
        String patternHam = ("HAMLET");
        Pattern pattern = Pattern.compile(patternHam,Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(hamletData);
        int counter = 0;

        while (matcher.find()){
            counter++;

        }
        System.out.println(counter);
       return counter;
    }
    public int findHoratio(){
        //Trying both methods out
        String REGEX_FIND_WORD="(?i).*?\\b%s\\b.*?";

        String patternHam = ("HORATIO");
        String regex = String.format(REGEX_FIND_WORD, Pattern.quote(patternHam));
        Pattern pattern = Pattern.compile(regex);
        Matcher matcher = pattern.matcher(hamletData);
        int counter = 0;

        while (matcher.find()){
            counter++;

        }
        System.out.println(counter);
        return counter;
    }

}
